#ifndef TEMPERATURE_DAPI_H
#define TEMPERATURE_DAPI_H

#include "BaseClassDAPI.hpp"
#include "TemperatureDDAPI.hpp"
//#include "MemoryDAPI.hpp"




class TemperatureDAPI : public BaseClassDAPI
{
    public: 
                         TemperatureDAPI(STRING className);
            virtual      ~TemperatureDAPI(void);
            ErrorMsg*   displayTemperatureNameList(list<string> *pTemperatureList);
            ErrorMsg*   getDataByName(STRING WellKnownName,
                                      TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
                                      list<string> *returnDataInfo);
            ErrorMsg*   setDataByName(STRING WellKnownName,
                                      TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
									  string SetValue);
/*

            ErrorMsg*   getLogicalIdByName(STRING WellKnownName, UINT32 *LogicalID);
            ErrorMsg*   getStatus(string  name, BOOL *pTemperatureStatus);
            ErrorMsg*   setStatus(string  name, BOOL Status);
*/

    private:
           ErrorMsg* getTemperatureDataAllInfo(STRING WellKnownName, list<string> *returnDataInfo);
           TemperatureDDAPI    *m_TemperatureDiver;
           ErrorMsg     *m_errorCode;






};

#endif
