#ifndef I2C_DDAPI_MAX66557_H
#define I2C_DDAPI_MAX66557_H

#include "I2CTemperatureBaseClass.hpp"

#define RLTS  0x00   //Read Internal Temperature
#define RLHN  0x05   //Read Internal High Limit
#define RLLI  0x06   //Read Internal Low Limit
#define WLHO  0x0B   //Write Internal High Limit
#define WLLM  0x0C   //Write Internal Low Limit
#define RIET  0x11   //Read Internal Extended Temperature



class MAX6657 : public I2CTemperature
{
public:
               MAX6657(STRING in_szClassName);
               ~MAX6657();

    ErrorMsg*  GetCurrntTemperature(string wellknow_name, string *result);
    ErrorMsg*  GetThresholdHigh(string wellknow_name, string *result);
    ErrorMsg*  GetThresholdLow(string wellknow_name, string *result);
    ErrorMsg*  SetThresholdHigh(string wellknow_name, string data);
    ErrorMsg*  SetThresholdLow(string wellknow_name, string data);


protected:

private:
    ErrorMsg   *m_errorCode;
};

#endif
