#include "TemperatureDDAPI.hpp"
//#include "GPIO_FPGADriver.hpp"

TemperatureDDAPI::TemperatureDDAPI(STRING className) : BaseClassDDAPI(className)
{
    //printf("%s\n", __func__);
    //FILE  *pFile;
    //char  line[500], teg[20];
    //int   teg_number, string_length;



    list<string> TempGPIODeviceBusPortList;
    TempGPIODeviceBusPortList.clear();



    for(UINT32 index = 0; index <  MAX_NUMBER_OF_TEMPERATURE_DRIVERS; index++)
        m_TemperatureDriverList[index] = (CHAR)NULL;

/*
    pFile=fopen (PROFILE_PATH_NAME,"r");
    if (pFile == NULL)
    {
        //printf("Error opening file\n");
        addErrorMsg((ERRORCODE)(ERROR_TEMPERATURE_DDAPI_CONSTRUCTOR | ERROR_TEMPERATURE_DDAPI_OPEN_PROFILE_FAIL), NULL);
        return;
    }

    //Read each line of I2C_profile.ini
    while (fgets(line, 500, pFile) != NULL)
    {
        if (line[0] == '#')
            continue;

        teg_number = sscanf(line, "[%[^]]", teg); //paser the teg:BUS, Topology, Protocol
        if ( (strlen(line) == 1 && line[0] == '\n') || (teg_number != 0))
        {
            continue;
        }
        //printf("Teg(%d):%s line:%s",teg_number, teg, line);

        //Remove the '\n' at the end of line
        string_length = strlen(line);
        if (line[string_length-1] == '\n')
        {
            line[string_length-1] = '\0';
        }
        //Start parser by teg
        if ( strcmp(teg,"FPGA") == 0 )
        {
            //Initial_I2C_BUS(line);
            //printf("!!!!\n");
            m_TemperatureDriverList[TEMPERATURE_FPGA_DRIVER] = new TemperatureFPGADriver("TEMPERATURE_FPGA");
            tempTag = TEMPERATURE_FPGA_DRIVER;
            //printf("%d\n", TEMPERATURE_FPGA_DRIVER);
            memset(teg, 0, sizeof(teg));
        }

        if ( strcmp(teg,"MIDPLANE") == 0 )
        {
            //Initial_I2C_BUS(line);
            //printf("!!!!\n");
            //m_TemperatureDriverList[TEMPTERATURE_MIDPLANE_RIVER] = new TemperatureFPGADriver("TEMPTERATURE_FPGA");
            tempTag = TEMPTERATURE_MIDPLANE_RIVER;
            //printf("%d\n", TEMPTERATURE_MIDPLANE_RIVER);

            memset(teg, 0, sizeof(teg));
        }

        switch(tempTag)
        {
            case TEMPTERATURE_FPGA_DRIVER:
                m_GPIODriverList[GPIO_FPGA_DRIVER]->readINIFile(line);
                break;
            case TEMPTERATURE_MIDPLANE_RIVER:
                break;
            case TEMPTERATURE_MAX_TYPE_NUMBER:
                break;
            default:
                break;
        }

    }
    fclose(pFile);

*/
    //memset(TemperatureConfig, "", sizeof(TemperatureConfig));
/*
    for(UINT32 index = 0; index < MAX_TEMPTERATURE_DEVICE_NO; index++)
    {
        TemperatureConfig[index].LogicalID          = TEMPTERATURE_ID_UNDEFINED;
        TemperatureConfig[index].WellKnownName[0]   = (CHAR)NULL;
        TemperatureConfig[index].DeviceNode[0]      = (CHAR)NULL;
        TemperatureConfig[index].BusPortAddress[0]  = (CHAR)NULL;
    }
    for(UINT32 index = 0; index < MAX_DATA_ELEMENT_NUMBER; index++)
    {
        TemperatureElementMap[index].DateElement  = MAX_DATA_ELEMENT_NUMBER;
        TemperatureElementMap[index].FileName[0]  = (CHAR)NULL;
    }
    */

/*
    for(UINT32 index = 0; index < MAX_DATA_ELEMENT_NUMBER; index++)
    {
        TEMPTERATURE_DATA_ELEMENT eCurrent = TEMPTERATURE_DATA_ELEMENT(index);
        TemperatureElementMap[eCurrent].DateElement = TEMPTERATURE_DATA_ALL_INFO;
        switch(eCurrent)
        {
            case TEMPTERATURE_DATA_ALL_INFO:
                TemperatureElementMap[eCurrent].FileName[0] = (CHAR)NULL;
                break;
            case TEMPTERATURE_DATA_NODE_INFO:
                TemperatureElementMap[eCurrent].FileName[0]= (CHAR)NULL;
                break;
            case TEMPTERATURE_DATA_SN_INFO:
                sprintf(TemperatureElementMap[eCurrent].FileName,"%s", "serial");
                break;
            case TEMPTERATURE_DATA_VENDOR_INFO:
                sprintf(TemperatureElementMap[eCurrent].FileName,"%s", "manufacturer");
                break;
            case TEMPTERATURE_DATA_CAPACITY_INFO:
                sprintf(TemperatureElementMap[eCurrent].FileName,"%s", "size");
                break;
            case TEMPTERATURE_DATA_LINK_INFO:
                sprintf(TemperatureElementMap[eCurrent].FileName,"%s", "version");
                break;
            case TEMPTERATURE_DATA_SPEED_INFO:
                sprintf(TemperatureElementMap[eCurrent].FileName,"%s", "speed");
            case MAX_DATA_ELEMENT_NUMBER:
                break;
            default:
                break;

        }
    }
    */

}

TemperatureDDAPI::~TemperatureDDAPI()
{
    for(UINT32 Index = 0; Index <  MAX_NUMBER_OF_TEMPERATURE_DRIVERS; Index++)
    {
        if(m_TemperatureDriverList[Index] != NULL )
            delete m_TemperatureDriverList[Index];
    }

}

ErrorMsg *TemperatureDDAPI::getTemperatureNameList(list<string> *pTemperatureList)
{
    //printf("%s\n", __func__);

    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    INT32 intIndex = 0;
    TEMPERATURE_TYPE   tempTag;


    while (intIndex < INT32(TEMPERATURE_TYPE_MAX_NUMBER)/*MAX_NUMBER_OF_TEMPERATURE_DRIVERS*/)
    {
        tempTag = TEMPERATURE_TYPE(intIndex);
        switch(tempTag)
        {
            case TEMPERATURE_PCM_DRIVER:
                break;
            case TEMPERATURE_SATA_DRIVER:
            	/*
                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_SATA_DRIVER] = new Temperature_SATA("TEMP_SATA");

                if(m_TemperatureDriverList[TEMPERATURE_SATA_DRIVER] != NULL)
                {
                	pErrorMsg = m_TemperatureDriverList[TEMPERATURE_SATA_DRIVER]->getTemperatureNameList(pTemperatureList);
               		if(pErrorMsg != NO_ERROR_MSG)
                	{
                		return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE,NULL,pErrorMsg);
                	}
                }
                */
                break;
            case TEMPERATURE_SAS_DRIVER:
            	/*
                m_TemperatureDriverList[TEMPERATURE_SAS_DRIVER] = new Temperature_SAS("TEMP_SAS");
                if(m_TemperatureDriverList[TEMPERATURE_SAS_DRIVER] != NULL)
                {
                    pErrorMsg = m_TemperatureDriverList[TEMPERATURE_SAS_DRIVER]->getTemperatureNameList(pTemperatureList);
               		if(pErrorMsg != NO_ERROR_MSG)
                	{
                		return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE,NULL,pErrorMsg);
                	}
                }
                */
                break;
            case TEMPERATURE_PSU_DRIVER:
            	/*
                m_TemperatureDriverList[TEMPERATURE_PSU_DRIVER] = new Temperature_PSU("TEMP_PSU");
                if(m_TemperatureDriverList[TEMPERATURE_PSU_DRIVER] != NULL)
                {
                    pErrorMsg = m_TemperatureDriverList[TEMPERATURE_PSU_DRIVER]->getTemperatureNameList(pTemperatureList);
               		if(pErrorMsg != NO_ERROR_MSG)
                	{
                		return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE,NULL,pErrorMsg);
                	}
                }
                */
                break;
            case TEMPERATURE_EXPANDER_DRIVER:
                break;
            case TEMPERATURE_I2C_DRIVER:
                m_TemperatureDriverList[TEMPERATURE_I2C_DRIVER] = new Temperature_I2C("TEMP_I2C");
                if(m_TemperatureDriverList[TEMPERATURE_I2C_DRIVER] != NULL)
                {
                	pErrorMsg = m_TemperatureDriverList[TEMPERATURE_I2C_DRIVER]->getTemperatureNameList(pTemperatureList);
                	if(pErrorMsg != NO_ERROR_MSG)
                	{
                		return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE,NULL,pErrorMsg);
                	}
                }
                break;
            case TEMPERATURE_CPU_DRIVER:
            	/*
                m_TemperatureDriverList[TEMPERATURE_CPU_DRIVER] = new Temperature_CPU("TEMP_CPU");
                if(m_TemperatureDriverList[TEMPERATURE_CPU_DRIVER] != NULL)
                {
                    pErrorMsg = m_TemperatureDriverList[TEMPERATURE_CPU_DRIVER]->getTemperatureNameList(pTemperatureList);
                	if(pErrorMsg != NO_ERROR_MSG)
                	{
                		return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_CURRENT_TEMPERATURE,NULL,pErrorMsg);
                	}
                }
                */
                break;
            case TEMPERATURE_TYPE_MAX_NUMBER:
                break;
            default:
                break;
        }
        intIndex++;
    }

    return NO_ERROR_MSG;
}


ErrorMsg*  TemperatureDDAPI::getDataByName(STRING WellKnownName,
                                           TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
                                           list<string> *returnDataInfo)
{
/*

    printf("%s\n", __func__);
    printf("WellKnownName:%s\n", WellKnownName);
    printf("TemperatureDataElement:%d\n", TemperatureDataElement);
*/

    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
    INT32 intIndex = 0;
    TEMPERATURE_TYPE   tempTag;


    while (intIndex < INT32(TEMPERATURE_TYPE_MAX_NUMBER)/*MAX_NUMBER_OF_TEMPERATURE_DRIVERS*/)
    {
        tempTag = TEMPERATURE_TYPE(intIndex);
        switch(tempTag)
        {
            case TEMPERATURE_PCM_DRIVER:
                break;
            case TEMPERATURE_SATA_DRIVER:
            	//printf("SATA\n");
            	/*
                m_TemperatureDriverList[TEMPERATURE_SATA_DRIVER] = new Temperature_SATA("TEMP_SATA");
                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_SATA_DRIVER]->getDataByName(WellKnownName, TemperatureDataElement, returnDataInfo);
                if(pErrorMsg != NO_ERROR_MSG)
                {
                	return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, NULL, pErrorMsg);
                }
                */
                break;
            case TEMPERATURE_SAS_DRIVER:
            	//printf("SAS\n");
            	/*
                m_TemperatureDriverList[TEMPERATURE_SAS_DRIVER] = new Temperature_SAS("TEMP_SAS");
                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_SAS_DRIVER]->getDataByName(WellKnownName, TemperatureDataElement, returnDataInfo);
                if(pErrorMsg != NO_ERROR_MSG)
                {
                	return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, NULL, pErrorMsg);
                }
                */
                break;
            case TEMPERATURE_PSU_DRIVER:
            	//printf("PSU\n");
            	/*
                m_TemperatureDriverList[TEMPERATURE_PSU_DRIVER] = new Temperature_PSU("TEMP_PSU");
                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_PSU_DRIVER]->getDataByName(WellKnownName, TemperatureDataElement, returnDataInfo);
                if(pErrorMsg != NO_ERROR_MSG)
                {
                	return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, NULL, pErrorMsg);
                }
                */
                break;
            case TEMPERATURE_EXPANDER_DRIVER:
                break;
            case TEMPERATURE_I2C_DRIVER:
            	//printf("I2C\n");
            	m_TemperatureDriverList[TEMPERATURE_I2C_DRIVER] = new Temperature_I2C("TEMP_I2C");
                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_I2C_DRIVER]->getDataByName(WellKnownName, TemperatureDataElement, returnDataInfo);
                if(pErrorMsg != NO_ERROR_MSG)
                {
                	return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, NULL, pErrorMsg);
                }

                break;
            case TEMPERATURE_CPU_DRIVER:
            	//printf("CPU\n");
            	/*
                m_TemperatureDriverList[TEMPERATURE_CPU_DRIVER] = new Temperature_CPU("TEMP_CPU");
                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_CPU_DRIVER]->getDataByName(WellKnownName, TemperatureDataElement, returnDataInfo);
                if(pErrorMsg != NO_ERROR_MSG)
                {
                	return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, NULL, pErrorMsg);
                }
                */
                break;

            //case TEMPERATURE_TYPE_MAX_NUMBER:
            	//return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, "Not Support This Temperature Type");
            //    break;
            default:
            	return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, "Not Support This Temperature Type");
                break;
        }
        if (pErrorMsg != NO_ERROR_MSG)
		{
        	//break;
		}
        intIndex++;
    }

    if(returnDataInfo->empty())
    	return returnErrorMsg(ERROR_TEMPERATURE_DDAPI_GET_DATA_BY_NAME, "Unknow well-known name");

    return NO_ERROR_MSG;
}

ErrorMsg*  TemperatureDDAPI::setDataByName(STRING WellKnownName,
											TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
											string SetValue)
{
	/*

	    printf("%s\n", __func__);
	    printf("WellKnownName:%s\n", WellKnownName);
	    printf("TemperatureDataElement:%d\n", TemperatureDataElement);
	*/

	    ErrorMsg*   pErrorMsg = NO_ERROR_MSG;
	    INT32 intIndex = 0;
	    TEMPERATURE_TYPE   tempTag;

	    while (intIndex < INT32(TEMPERATURE_TYPE_MAX_NUMBER)/*MAX_NUMBER_OF_TEMPERATURE_DRIVERS*/)
	    {
	        tempTag = TEMPERATURE_TYPE(intIndex);
	        switch(tempTag)
	        {
	            case TEMPERATURE_PCM_DRIVER:
	                break;
	            case TEMPERATURE_SATA_DRIVER:
	            	/*
	                m_TemperatureDriverList[TEMPERATURE_SATA_DRIVER] = new Temperature_SATA("TEMP_SATA");
	                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_SATA_DRIVER]->setDataByName(WellKnownName, TemperatureDataElement, SetValue);
	                if (pErrorMsg != NO_ERROR_MSG)
	                {
	                    //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
	                }
*/
	                break;
	            case TEMPERATURE_SAS_DRIVER:
	            	/*
	                m_TemperatureDriverList[TEMPERATURE_SAS_DRIVER] = new Temperature_SAS("TEMP_SAS");
	                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_SAS_DRIVER]->setDataByName(WellKnownName, TemperatureDataElement, SetValue);
	                if (pErrorMsg != NO_ERROR_MSG)
	                {
	                    //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
	                }
	                */
	                break;
	            case TEMPERATURE_PSU_DRIVER:
	            	/*
	                m_TemperatureDriverList[TEMPERATURE_PSU_DRIVER] = new Temperature_PSU("TEMP_PSU");
	                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_PSU_DRIVER]->setDataByName(WellKnownName, TemperatureDataElement, SetValue);
	                if (pErrorMsg != NO_ERROR_MSG)
	                {
	                    //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
	                }
	                */
	                break;
	            case TEMPERATURE_EXPANDER_DRIVER:
	                break;
	            case TEMPERATURE_I2C_DRIVER:
	            	m_TemperatureDriverList[TEMPERATURE_I2C_DRIVER] = new Temperature_I2C("TEMP_I2C");
	                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_I2C_DRIVER]->setDataByName(WellKnownName, TemperatureDataElement, SetValue);
	                if (pErrorMsg != NO_ERROR_MSG)
	                {
	                    //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
	                }

	                break;
	            case TEMPERATURE_CPU_DRIVER:
	            	/*
	                m_TemperatureDriverList[TEMPERATURE_CPU_DRIVER] = new Temperature_CPU("TEMP_CPU");
	                pErrorMsg = m_TemperatureDriverList[TEMPERATURE_CPU_DRIVER]->setDataByName(WellKnownName, TemperatureDataElement, SetValue);
	                if (pErrorMsg != NO_ERROR_MSG)
	                {
	                    //return returnErrorMsg(ERROR_TEMPERATURE_DAPI_DISPLAY_TEMPERATURE_LIST, NULL, m_errorCode);
	                }
	                */
	                break;
	            case TEMPERATURE_TYPE_MAX_NUMBER:
	                break;
	            default:
	                break;
	        }
	        intIndex++;
	    }

	    return NO_ERROR_MSG;
}







