#include "FPGAModule.hpp"
#include "FPGACommand.hpp"


FPGAModule::FPGAModule(string in_strName) : ModuleBaseClass(in_strName)
{
    addCommand(new FPGACommand(CMD_LIST, "List supported FPGA"));
    addCommand(new FPGACommand(CMD_SHOW, "Show FPGA information"));
    addCommand(new FPGACommand(CMD_SPAD, "FPGA scratch pad access"));
    addCommand(new FPGACommand(CMD_UTILITY, "FPGA operation access"));
}

FPGAModule::~FPGAModule()
{

}
