#ifndef GPIO_OPERATION_H
#define GPIO_OPERATION_H

#include <stdio.h>
#include <iostream>
#include <string>
#include "OperationBaseClass.hpp"
#include "GPIODAPI.hpp"

//using namespace std;

//#define OPRATION_HELP  "help"

//Define opration type
/*
enum GPIO_OPRATION_TYPE {
    NO_OPRATION = 0,
    READ,
    WRITE,
};
*/


class GPIOOperation: public OperationBaseClass
{
    public:
                GPIOOperation(OPERATION_TYPE, string);
       virtual  ~GPIOOperation();

                //Decide which operation to be executed
                int  executeOperation(StringParser);

                //List GPIO device node
                int executeList(StringParser);

                //Show GPIO device characteristics
                int executeUtility(StringParser);

                //Execute test command
                //int executeTest(StringParser);

                //Show parameter message here
                int  helpParameter();

                //Check parameter syntax here
                int  checkSyntax(StringParser);
                
    private:
                OPERATION_TYPE  m_OperationType;
                GPIODAPI         *m_pGPIODAPI;
};

#endif
