#ifndef  RTC_OPERATION_H
#define  RTC_OPERATION_H

#include <stdio.h>
#include <iostream>
#include <string>
#include "OperationBaseClass.hpp"
#include "RTCDAPI.hpp"

using namespace std;

class  RTCOperation: public OperationBaseClass
{
    public:
                 RTCOperation(OPERATION_TYPE oprationType, string helpContent);
       virtual  ~ RTCOperation();

                //Decide which operation to be executed
                int  executeOperation(StringParser commandLine);
                //Show parameter message here
                void helpParameter(StringParser commandLine);
                //Operation implement here
                int  date(StringParser commandLine);
                int  time(StringParser commandLine);
                int  dateTime(StringParser commandLine);
                int  accuracy(StringParser commandLine);
                int  wdt(StringParser commandLine);

                //Check parameter syntax here
                int  checkSyntax(StringParser commandLine);
                
    private:

};

#endif
