#ifndef UARTDAPI_H
#define UARTDAPI_H

#include "BaseClassDAPI.hpp"
#include "UARTDDAPI.hpp"

class UARTDAPI : public BaseClassDAPI
{
    public:
                 UARTDAPI(STRING);
        virtual ~UARTDAPI();


        ErrorMsg*   getUartList(vector<SERIAL_INFO>*);
        ErrorMsg*   getUartInfoByName(STRING,  SERIAL_INFO*);
        ErrorMsg*   testScratchPad(STRING);

        ErrorMsg*   doInternalLoopbackTest(STRING     in_uartLogicalName,
                                           bool       in_interruptMode,
                                           UINT32     in_u32BufferSize,
                                           bool       in_userDefinedPattern,
                                           UINT8      in_u8Pattern);

    private:
        ErrorMsg*   m_pErrorMsg;
        UARTDDAPI*  m_pUartDriverAPI;


};





#endif

