#ifndef Temperature_SAS_H
#define Temperature_SAS_H

#include "TemperatureGeneric.hpp"
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>



class Temperature_SAS : public TemperatureGeneric
{
    public:
                       Temperature_SAS(STRING  ClassName);
                       ~Temperature_SAS();

                       ErrorMsg*  getTemperatureNameList(list<string> *pTemperatureList);

                       ErrorMsg*  getDataByName(STRING WellKnownName,
                    		   	   	   	   	    TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
												list<string> *returnDataInfo);

/*
             ErrorMsg* Setup_resource_path(string path, int id_index);

     virtual string Get_name();
     virtual ErrorMsg* Get_current_temperature(float *temp);
     virtual ErrorMsg* Get_threshold_hight(float *temp);
     virtual ErrorMsg* Get_threshold_low(float *temp);
     //virtual ErrorMsg* Set_name(string name);
     virtual ErrorMsg* Set_threshold_hight(float temp);
     virtual ErrorMsg* Set_threshold_low(float temp);
*/
    protected:

    private:
            SASDDAPI	*m_SASDdapi;

            ErrorMsg*   getCurrentTemperatureList(STRING WellKnownName,
                                                  list<string> *returnDataInfo);

            ErrorMsg*   getThresholdHigh0List(STRING WellKnownName, list<string> *pTemperatureList);
            ErrorMsg*   getThresholdLow0List(STRING WellKnownName, list<string> *pTemperatureList);
            ErrorMsg*   getThresholdHigh1List(STRING WellKnownName, list<string> *pTemperatureList);
            ErrorMsg*   getThresholdLow1List(STRING WellKnownName, list<string> *pTemperatureList);
            //string resource_path;
            //int    index;
};

#endif
